<template>
  <div style="width: 100%; height: 100%;">
    <div class="full_map_route">
      <div
        class="full_map_route_container"
        :class="{
          less: !expandRoute,
        }"
      >
        <template v-for="item in panelManeuver">
          <v-layout :key="item.id" class="route_item">
            <v-flex xs3>
              <v-chip color="orange" text-color="white">
                <v-icon left>{{
                  icons[item.direction ? item.direction : item.action]
                }}</v-icon>
              </v-chip>
            </v-flex>
            <v-flex xs9>
              <span v-html="item.instruction"> </span>
            </v-flex>
          </v-layout>
          <v-divider :key="item.id"></v-divider>
        </template>
      </div>
      <div class="fullmap_button_open">
        <v-btn block text @click="expandRoute = !expandRoute">
          <v-icon v-if="expandRoute">mdi-chevron-up</v-icon>
          <v-icon v-else>mdi-chevron-down</v-icon>
        </v-btn>
      </div>
    </div>
    <div ref="mapContainer" style="width: 100%; height: 100%;"></div>
    <div class="dialog_buttons">
      <v-btn fab text dark @click="close" class="transperent_dark_button">
        <v-icon>mdi-arrow-left-circle</v-icon>
      </v-btn>

      <v-btn
        text
        dark
        fab
        class="transperent_dark_button"
        @click="genRoute('shortest;pedestrian')"
      >
        <v-icon>mdi-walk</v-icon>
      </v-btn>
      <v-btn
        text
        dark
        fab
        class="transperent_dark_button"
        @click="genRoute('fastest;publicTransport')"
      >
        <v-icon>mdi-train</v-icon>
      </v-btn>
      <v-btn
        text
        dark
        fab
        class="transperent_dark_button"
        @click="genRoute('fastest;car')"
      >
        <v-icon>mdi-car</v-icon>
      </v-btn>
    </div>
  </div>
</template>
<script>
export default {
  data: function() {
    return {
      icons: {
        forward: "mdi-arrow-up",
        left: "mdi-arrow-left",
        right: "mdi-arrow-right",
        leave: "mdi-bus-stop",
        enter: "mdi-bus-stop",
      },
      expandRoute: false,
      mapObj: false,
      bubble: false,
      group: false,
      polyline: false,
      ui: false,
      destMarker: false,
      user: false,
      platform: false,

      panelManeuver: [],
    };
  },
  props: {
    value: {
      type: Boolean,
    },
    destenation: {
      type: Object,
    },
  },
  mounted: function() {
    this.initMap();
  },
  watch: {
    destenation: function() {
      this.destMarker.setPosition({
        lng: this.destenation.coords[1],
        lat: this.destenation.coords[0],
      });
    },
    position: function(current, prev) {
      this.user.setPosition({
        lat: this.position.coords.latitude,
        lng: this.position.coords.longitude,
      });
    },
  },

  computed: {
    position: function() {
      return this.$store.getters.getPosition;
    },
  },
  methods: {
    close: function() {
      this.$emit("input", false);
    },
    initMap: function() {
      // Initialize the platform object:
      var platform = new H.service.Platform({
        app_id: "acG6wu3lEemv7kBZMfFx",
        app_code: "ffJ9HkssdH3W1I_drrmmhQ",
        useHTTPS: true,
      });
      var maptypes = platform.createDefaultLayers({
        lg: "RUS",
        tileSize: 256,
        ppi: 120,
      });
      var coords = {
        lng: this.position.coords.longitude,
        lat: this.position.coords.latitude,
      };
      // Instantiate (and display) a map object:
      var map = new H.Map(this.$refs.mapContainer, maptypes.normal.map, {
        zoom: 12,
        center: coords,
      });
      var behavior = new H.mapevents.Behavior(new H.mapevents.MapEvents(map));
      this.ui = H.ui.UI.createDefault(map, maptypes);
      /*
            var animatedSvg =
            '<?xml version="1.0" encoding="iso-8859-1"?> <!-- Generator: Adobe Illustrator 19.0.0, SVG Export Plug-In . SVG Version: 6.00 Build 0)  --> <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Layer_1" x="0px" y="0px" viewBox="0 0 512 512" style="enable-background:new 0 0 512 512;" xml:space="preserve" width="26px" height="26px"> <g> <g> <path d="M256,0C153.755,0,70.573,83.182,70.573,185.426c0,126.888,165.939,313.167,173.004,321.035    c6.636,7.391,18.222,7.378,24.846,0c7.065-7.868,173.004-194.147,173.004-321.035C441.425,83.182,358.244,0,256,0z M256,278.719    c-51.442,0-93.292-41.851-93.292-93.293S204.559,92.134,256,92.134s93.291,41.851,93.291,93.293S307.441,278.719,256,278.719z" fill="#933EC5"/> </g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> </svg>'
            
            var icon = new H.map.DomIcon(animatedSvg);
            var userMarker = new H.map.DomMarker(coords, {icon: icon});
            */
      var userMarker = new H.map.Marker(coords);
      map.addObject(userMarker);
      userMarker.setZIndex(1000);

      this.user = userMarker;

      let desCoords = {
        lng: this.destenation.coords[1],
        lat: this.destenation.coords[0],
      };

      let destMarker = new H.map.Marker(desCoords);
      map.addObject(destMarker);
      destMarker.setZIndex(1000);
      //H.ui.i18n.Localization('ru-RU', map)
      this.mapObj = map;
      this.destMarker = destMarker;
      this.platform = platform;
    },

    genRoute: function(path) {
      let router = this.platform.getRoutingService();

      let routeRequestParams = {
        //mode: 'fastest;publicTransport',
        //mode: 'fastest;car',
        //mode: 'shortest;pedestrian',
        mode: path,
        representation: "display",
        language: "ru-ru",
        waypoint0:
          this.position.coords.latitude + "," + this.position.coords.longitude, // Fernsehturm
        waypoint1:
          this.destenation.coords[0] + "," + this.destenation.coords[1], // Kurfürstendamm
        routeattributes: "waypoints,summary,shape,legs",
        maneuverattributes: "direction,action",
      };

      router.calculateRoute(
        routeRequestParams,
        (result) => {
          let route = result.response.route[0];
          this.addRouteShapeToMap(route);
          this.addManueversToMap(route);
          this.addManueversToPanel(route);
        },
        (responce) => {
          console.log(responce);
        }
      );
    },
    addManueversToMap: function(route) {
      if (this.group) {
        this.mapObj.removeObject(this.group);
      }
      var svgMarkup =
          '<svg width="18" height="18" ' +
          'xmlns="http://www.w3.org/2000/svg">' +
          '<circle cx="8" cy="8" r="8" ' +
          'fill="#1b468d" stroke="white" stroke-width="1"  />' +
          "</svg>",
        dotIcon = new H.map.Icon(svgMarkup, { anchor: { x: 8, y: 8 } }),
        group = new H.map.Group(),
        i,
        j;

      // Add a marker for each maneuver
      for (i = 0; i < route.leg.length; i += 1) {
        if (route.leg[i].maneuver) {
          for (j = 0; j < route.leg[i].maneuver.length; j += 1) {
            // Get the next maneuver.
            let maneuver = route.leg[i].maneuver[j];
            // Add a marker to the maneuvers group
            var marker = new H.map.Marker(
              {
                lat: maneuver.position.latitude,
                lng: maneuver.position.longitude,
              },
              { icon: dotIcon }
            );
            marker.instruction = maneuver.instruction;
            group.addObject(marker);
          }
        }
      }

      /*
            group.addEventListener('tap',  (evt) => {
                this.mapObj.setCenter(evt.target.getPosition());
                this.openBubble(
                evt.target.getPosition(), evt.target.instruction);
            }, false);
            */
      // Add the maneuvers group to the map
      this.mapObj.addObject(group);
      this.group = group;
    },
    openBubble: function(position, text) {
      console.log(text);
      if (!this.bubble) {
        this.bubble = new H.ui.InfoBubble(
          position,
          // The FO property holds the province name.
          { content: "" }
        );
        this.ui.addBubble(this.bubble);
      } else {
        this.bubble.setPosition(position);
        this.bubble.setContent(text);
        this.bubble.open();
      }
    },

    addRouteShapeToMap: function(route) {
      if (this.polyline) {
        this.mapObj.removeObject(this.polyline);
      }
      var lineString = new H.geo.LineString(),
        routeShape = route.shape,
        polyline;

      routeShape.forEach(function(point) {
        var parts = point.split(",");
        lineString.pushLatLngAlt(parts[0], parts[1]);
      });

      polyline = new H.map.Polyline(lineString, {
        style: {
          lineWidth: 4,
          strokeColor: "rgba(0, 128, 255, 0.7)",
        },
      });
      // Add the polyline to the map
      this.mapObj.addObject(polyline);
      // And zoom to its bounding rectangle
      this.mapObj.setViewBounds(polyline.getBounds(), true);
      this.polyline = polyline;
    },
    addManueversToPanel: function(route) {
      this.panelManeuver = [];
      // Add a marker for each maneuver
      for (let i = 0; i < route.leg.length; i += 1) {
        for (let j = 0; j < route.leg[i].maneuver.length; j += 1) {
          // Get the next maneuver.
          let maneuver = route.leg[i].maneuver[j];

          this.panelManeuver.push(maneuver);
        }
      }
    },
  },
};
</script>
